Index: other-projects/hathitrust/worksets-from-extracted-features/trunk/index.html
===================================================================
--- other-projects/hathitrust/worksets-from-extracted-features/trunk/index.html	(revision 30993)
+++ other-projects/hathitrust/worksets-from-extracted-features/trunk/index.html	(revision 30993)
@@ -0,0 +1,327 @@
+<!DOCTYPE html>
+<html>
+  <head>
+    <base href="https://analytics.hathitrust.org/" />    
+        <title> HTRC Portal - Home </title>
+        <link rel="shortcut icon" href="/assets/images/favicon.ico"/>
+        <meta name="viewport" content="width=device-width, initial-scale=1.0">
+        <meta http-equiv="refresh" content="600">
+            <!-- Bootstrap -->
+        <link href="/assets/stylesheets/bootstrap.min.css" rel="stylesheet" media="screen">
+        <link href="/assets/stylesheets/main.css" rel="stylesheet" media="screen">
+        <link href="/assets/stylesheets/flat.css" rel="stylesheet" media="screen">
+        <link href="/assets/stylesheets/font-awesome.min.css" rel="stylesheet">
+        <link href="/assets/stylesheets/tomorrow.min.css" rel="stylesheet">
+        
+        <link rel="stylesheet" href="/theme">
+        
+        <script src="/assets/javascripts/highlight.min.js"></script>
+        <script src="/assets/javascripts/jquery.min.js"></script>
+        <script src="/assets/javascripts/stupidtable.min.js"></script>
+        <script src="/assets/javascripts/bootstrap.min.js"></script>
+        <script src="/assets/javascripts/bowser.min.js"></script>
+        <script type="text/javascript" src="/assets/javascripts/htrcwarnings.js"></script>
+        <script type="text/javascript" src="/assets/javascripts/uploadws.js"></script>
+        <script type="text/javascript" src="/assets/javascripts/ga-download-tracking.js"></script>
+
+  </head>
+  <body>
+        <nav class="navbar navbar-default navbar-fixed-top navbar-htrc" role="navigation">
+            <div class="container">
+                <div class="navbar-header">
+                    <button type="button" class="navbar-toggle" data-toggle="collapse" data-target="#bs-example-navbar-collapse-1">
+                        <span class="sr-only">Toggle navigation</span>
+                        <span class="icon-bar"></span>
+                        <span class="icon-bar"></span>
+                        <span class="icon-bar"></span>
+                    </button>
+                    <a class="navbar-brand" href="/"><img src="/assets/images/hathi.jpg"
+                    width="36" height="32" style="padding-right : 5 px ; margin-top : - 1 px ;" alt=" ">
+                        HTRC Portal
+                    </a>
+                </div>
+
+                <div class="navbar-collapse collapse">
+                    <ul class="nav navbar-nav">
+                        <li><a href="/">Home</a></li>
+                        </li>
+
+                        <li class="dropdown">
+                            <a href="#" class="dropdown-toggle" data-toggle="dropdown">
+                                Worksets <b class="caret"></b></a>
+                            <ul class="dropdown-menu">
+                                
+                                    <li><a href="#" onclick="loggingRequiredWarning('/listuserworksets')" >View my worksets</a></li>
+                                
+                                <li class="divider"></li>
+                                
+                                    <li><a href="#" onclick="loggingRequiredWarning('/listallworksets')">View all worksets</a></li>
+                                
+                                <li class="divider"></li>
+                                
+                                    <li><a href="#" onclick="loggingRequiredWarning('/uploadworkset')">Upload workset</a></li>
+                                
+                                <li class="divider"></li>
+                                <li>
+                                    <a href="#" onclick="blacklightLoggingWarning ( '      https://analytics.hathitrust.org/blacklight ')">
+                                        Create workset</a>
+                                </li>
+                            </ul>
+                        </li>
+                        
+                            <li><a href="#" onclick="loggingRequiredWarning('/listalgorithms')" >Algorithms</a></li>
+                        
+                        
+                            <li><a href="#" onclick="loggingRequiredWarning('/listjobs')">Results</a></li>
+                        
+                        
+                            <li class="dropdown">
+                                <a href="#" class="dropdown-toggle" data-toggle="dropdown">
+                                    Capsule<b class="caret"></b></a>
+                                <ul class="dropdown-menu">
+                                    <li><a href="https://wiki.htrc.illinois.edu/display/COM/HTRC+Data+Capsule">
+                                        Documentation</a>
+                                    </li>
+                                    <li class="divider"></li>
+                                    
+                                        <li><a href="#" onclick="loggingRequiredWarning('/listvms')" >
+                                            Show Capsules</a></li>
+                                    
+                                    <li class="divider"></li>
+                                    
+                                        <li><a href="#" onclick="loggingRequiredWarning('/createvms')" >
+                                            Create Capsule</a></li>
+                                    
+                                </ul>
+                            </li>
+                        
+                        <li class="dropdown">
+                            <a href="#" class="dropdown-toggle" data-toggle="dropdown">
+                                Data<b class="caret"></b></a>
+                            <ul class="dropdown-menu">
+                                <li><a href="/features">
+                                    Extracted Features Dataset</a>
+                                </li>
+                                <li><a href="/genre">
+                                    Word Frequencies in English-Language Literature, 1700-1922</a>
+                                </li>
+                            </ul>
+                        </li>
+                        <li class="dropdown">
+                            <a href="#" class="dropdown-toggle" data-toggle="dropdown">
+                                Help<b class="caret"></b></a>
+                            <ul class="dropdown-menu">
+                                <li><a href="https://wiki.htrc.illinois.edu/display/COM/HTRC+User+Getting+Started+FAQ">
+                                    Knowledge Base</a>
+                                </li>
+                                <li class="divider"></li>
+                                <li><a href="mailto:htrc-help@hathitrust.org?Subject=Contact">
+                                    Contact</a>
+                                </li>
+                            </ul>
+                        </li>
+                        <li><a href="/about">About</a>
+                    </ul>
+                    
+                        <ul class="nav pull-right navbar-nav">
+                            <li class="dropdown">
+                                <a href="#" class="dropdown-toggle" data-toggle="dropdown">
+                                    Sign In<b class="caret"></b></a>
+                                <ul class="dropdown-menu">
+                                    <li><a href="/login">Sign In</a></li>
+                                    <li class="divider"></li>
+                                    <li><a href="/passwordresetmail">
+                                        Forgot Password?</a></li>
+                                </ul>
+                            </li>
+
+
+                            <li><a href="/signup"><span>Sign Up</span></a></li>
+                        </ul>
+                    
+                </div>
+                    <!--/.nav-collapse -->
+            </div>
+        </nav>
+        
+        
+
+    <div class="container container-panel" style="padding-top: 15px; padding-bottom: 15px;">
+        <div class="row">
+            <div class="col-md-2 col-sm-2 hidden-xs">
+                <img class="img-responsive"  src="/assets/images/hathi.jpg" alt=" ">
+            </div>
+            <div class="col-md-10 col-sm-10 col-xs-12 col-lg-8" style="margin-left: 0;">
+                <h1 style="font-weight:bold;font-size:56px">
+                    Worksets from Extract Features
+                </h1>
+            </div>
+        </div>
+        <div class="row" style="padding-top : 25px; font-size : 17px; line-height : 27px;">
+            <div class="col-md-12">
+              <p>Fledgling portal, primarily giving&mdash;at this
+	         stage&mdash;access to the behind-the-scenes
+	         infrastructure being developed to ingest HTRC
+	         Extracted Feature JSON data into a Solr cloud.</p>
+	      <ul>
+		<li>
+		  <a href="http://10.10.0.52:8080">Hadoop Cluster Web Interface</a> (master
+		  node, for observing active and previous ingests)
+		</li>
+		<li>
+		  <a href="http://10.11.0.53:8983/solr">Solr Cloud web interface</a> (solr1 node, giving access
+		  to full Solr API, but in a raw form)
+		</li>
+	      </ul>
+                    
+
+            </div>
+        </div>
+
+	<!--
+       <div class="row">
+            <div class="col-md-12" style="margin-top : 20px;">
+                <h2 style="margin-top : 0">What would you like to do today?</h2>
+            </div>
+        </div>
+
+        <div class="row">
+            <div class="col-md-3">
+                <div class="panel panel-default panel-htrc margin-bt-0">
+                    <div class="panel-heading">
+                        <a href="#" class="dropdown-toggle" data-toggle="dropdown" onclick="blacklightLoggingWarning('https://analytics.hathitrust.org/blacklight')">Create Workset</a>
+                    </div>
+                    <div class="panel-body">
+                        <div class="text-content">Create workset using our workset builder.</div>
+                     </div>
+                </div>
+            </div>
+            <div class="col-md-3">
+                <div class="panel panel-default panel-htrc margin-bt-0">
+                    <div class="panel-heading">
+                        
+                            <a href="#" onclick="loggingRequiredWarning('/uploadworkset')">Upload Workset</a>
+                        
+                    </div>
+                    <div class="panel-body">
+
+                        <div class="text-content">Upload a workset by specifying the
+                            necessary data about its volumes through a text file.</div>
+                        </div>
+                </div>
+            </div>
+            <div class="col-md-3">
+                <div class="panel panel-default panel-htrc margin-bt-0">
+                    <div class="panel-heading">
+                        
+                            <a href="#" onclick="loggingRequiredWarning('/listallworksets')">Browse Workset</a>
+                        
+                    </div>
+                    <div class="panel-body">
+                        <div class="text-content">Browse through already created worksets.</div>
+                    </div>
+                </div>
+            </div>
+            <div class="col-md-3">
+                <div class="panel panel-default panel-htrc margin-bt-0">
+                    <div class="panel-heading">
+                        
+                            <a href="#" onclick="loggingRequiredWarning('/listalgorithms')">Execute Algorithms</a>
+                        
+                    </div>
+                    <div class="panel-body">
+
+                                    <div class="text-content">Select and execute
+                                        text analysis algorithms for word count to more sophisticated
+                                        approaches.</div>
+
+                    </div>
+                </div>
+            </div>
+	
+        </div>
+	-->
+
+    </div>
+
+
+	
+        <div class="container">
+        <p style="text-align: center; font-size: small; margin-top: 10px;">HTRC Portal (<a href="https://wiki.htrc.illinois.edu/display/COM/HTRC+Service+Release+v3.1+for+Uncamp+2015" target="_blank">v3.2.x</a>)
+        </p>
+        </div>
+
+        
+        <div id="push"></div>
+        
+        
+        
+        
+        
+        
+        
+        
+        
+        
+        <div class="modal fade" id="create-collection-modal" aria-hidden="true" tabindex="-1" role="dialog">
+            <div class="modal-dialog">
+                <div class="modal-content">
+                    <div class="modal-header">
+                        <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
+                        <h4 class="modal-title">Create Workset</h4>
+                    </div>
+                    <div class="modal-body">
+                        <p>You are being redirected to the Workset Builder.
+                            If this is the first time accessing it during this browser session,
+                            you will need to select "Login" from the top-right menu bar before creating or modifying a workset.
+                            We are aware this is inconvenient and we're working on a technical solution to eliminate this requirement.</p>
+                    </div>
+                    <div class="modal-footer">
+                        <span class="pull-left" style="padding-top : 5 px ;"><input type="checkbox" id="dont-show" style="margin : - 3 px 0 0 ;">
+                            Don't Show This Again.</span>
+                        <a href="#" class="btn btn-link btn-sm" data-dismiss="modal" aria-hidden="true">Cancel</a>
+                        <a id="modal-wb-url" href="" class="btn btn-sm btn-primary" onclick="goToCreateCollection ( )">
+                            Go</a>
+                    </div>
+                </div>
+            </div>
+        </div>
+        <div class="modal fade" id="login-required-modal" aria-hidden="true" tabindex="-1" role="dialog">
+            <div class="modal-dialog">
+                <div class="modal-content">
+                    <div class="modal-header">
+                        <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
+                        <h4 class="modal-title">Please Sign in</h4>
+                    </div>
+                    <div class="modal-body">
+                        <p>You need to sign in to access this functionality.</p>
+                    </div>
+                    <div class="modal-footer">
+                        
+                        
+                        <a href="#" class="btn btn-link btn-sm" data-dismiss="modal" aria-hidden="true">Cancel</a>
+                        <a id="modal-target-url" href="" data-toggle="modal" class="btn btn-sm btn-primary">
+                            Go</a>
+                    </div>
+                </div>
+            </div>
+        </div>
+
+	<!--
+        <script>
+            (function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
+            (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
+            m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
+            })(window,document,'script','//www.google-analytics.com/analytics.js','ga');
+
+            ga('create', 'UA-42842720-8', 'auto');
+            ga('send', 'pageview');
+        </script>
+	-->
+	
+  </body>
+
+
+
+</html>
+