Index: other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/RUN-PD-MASTER-LOCAL.bash
===================================================================
--- other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/RUN-PD-MASTER-LOCAL.bash	(revision 31041)
+++ 	(revision )
@@ -1,12 +1,0 @@
-#!/bin/bash
-
-json_filelist="file://`pwd`/${1:-pd-file-listing-step10000.txt}"
-shift
-
-input_dir="file://`pwd`/pd-ef-json-files"
-output_dir="file://`pwd`/pd-solr-json-files"
-
-master_opt="--master local[4]"
-
-. ./_RUN.bash $*
-
Index: other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/RUN-PD-MASTER-SPARK.bash
===================================================================
--- other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/RUN-PD-MASTER-SPARK.bash	(revision 31041)
+++ 	(revision )
@@ -1,14 +1,0 @@
-#!/bin/bash
-
-json_filelist=${1:-pd-file-listing-step10000.txt}
-shift
-
-input_dir="hdfs://master:9000/user/htrc/pd-ef-json-files"
-#input_dir="hdfs://10.10.0.52:9000/user/htrc/pd-ef-json-files"
-
-#output_dir=hdfs://master:9000/user/htrc/pd-solr-json-files
-solr_url="http://10.11.0.53:8983/solr/htrc-pd-ef/update"
-
-master_opt="--master spark://10.10.0.52:7077"
-
-. ./_RUN.bash
Index: other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/_RUN.bash
===================================================================
--- other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/_RUN.bash	(revision 31041)
+++ 	(revision )
@@ -1,100 +1,0 @@
-#!/bin/bash
-
-# To work, the follow bash variables need to have been set:
-#
-#  json_filelist input_dir output_dir
-#
-# Typically done through running a wrapper script, such as:
-#
-#  RUN-PD-CLUSTER.bash
-
-if [ "x$json_filelist" = "x" ] ; then
-    echo "_RUN.bash: Failed to set 'json_filelist'" 1>&2
-    exit
-fi
-
-if [ "x$input_dir" = "x" ] ; then
-    echo "_RUN.bash: Failed to set 'input_dir'" 1>&2
-    exit
-fi
-
-#if [ "x$output_dir" = "x" ] ; then
-#    echo "_RUN.bash: Failed to set 'output_dir'" 1>&2
-#    exit
-#fi
-
-run_jps=0
-run_jps_daemons=""
-run_jps_daemons_suffix="daemon"
-using_hdfs=0
-
-if [ "x${input_dir##hdfs://*}" = "x" ] || [ "x${output_dir##hdfs://*}" = "x" ] ; then
-    # Evidence of running command over HDFS
-    run_jps=1
-    run_jps_daemons="Spark"
-    using_hdfs=1
-fi
-
-if [ "x${master_opt##--master spark://*}" = "x" ] ; then
-    # Evidence of running command submitted to Spark cluster
-    run_jps=1
-    if [ "x$run_jps_daemons" != "x" ] ; then
-        run_jps_daemons="$run_jps_daemons and Hadoop"
-	run_jps_daemons_suffix="daemons"
-    else
-        run_jps_daemons="Hadoop"
-    fi
-fi
-
-if [ "$run_jps" = "1" ] ; then
-  echo
-  echo "****"
-  echo "* Checking for $run_jps_daemons $run_jps_daemons_suffix, by running 'jps':"
-  echo "****"
-  jps | egrep -v " Jps$" |  sed 's/^/* /g'
-  echo "****"
-  echo "* Done"
-  echo "****"
-  echo
-
-  sleep 1
-fi
-
-if [ "$using_hdfs" = "1" ] ; then
-  hadoop fs -test -d "$output_dir"
-
-  if [ $? != 0 ] ; then
-      echo "Creating directory:"
-      echo "  $output_dir"
-  fi
-fi
-    
-self_contained_jar=target/htrc-ef-ingest-0.9-jar-with-dependencies.jar
-cmd="spark-submit --class org.hathitrust.extractedfeatures.ProcessForSolrIngest $master_opt $self_contained_jar"
-
-if [ "x$solr_url" != "x" ] ; then
-    cmd="$cmd --solr-url $solr_url"
-fi
-
-if [ "x$output_dir" != "x" ] ; then
-    cmd="$cmd --output-dir $output_dir"
-fi
-
-
-cmd="$cmd --properties ef-solr.properties $input_dir $json_filelist $*"
-
-echo "****"
-echo "* Lauching:"
-echo "*   $cmd"
-echo "****"
-
-if [ "$run_jps" = "1" ] ; then
-  echo "* Monitor progress on Spark cluster through:"
-  echo "*   http://10.10.0.52:8080/"
-  echo "****"
-fi
-echo
-sleep 2
-
-$cmd
-
Index: other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/scripts/PD-RUN-MASTER-LOCAL.sh
===================================================================
--- other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/scripts/PD-RUN-MASTER-LOCAL.sh	(revision 31042)
+++ other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/scripts/PD-RUN-MASTER-LOCAL.sh	(revision 31042)
@@ -0,0 +1,12 @@
+#!/bin/bash
+
+json_filelist="file://`pwd`/${1:-pd-file-listing-step10000.txt}"
+shift
+
+input_dir="file://`pwd`/pd-ef-json-files"
+output_dir="file://`pwd`/pd-solr-json-files"
+
+master_opt="--master local[4]"
+
+. scripts/_RUN.sh 
+
Index: other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/scripts/PD-RUN-MASTER-SPARK.sh
===================================================================
--- other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/scripts/PD-RUN-MASTER-SPARK.sh	(revision 31042)
+++ other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/scripts/PD-RUN-MASTER-SPARK.sh	(revision 31042)
@@ -0,0 +1,15 @@
+#!/bin/bash
+
+json_filelist=${1:-pd-file-listing-step10000.txt}
+shift
+
+input_dir="hdfs://master:9000/user/htrc/pd-ef-json-files"
+#input_dir="hdfs://10.10.0.52:9000/user/htrc/pd-ef-json-files"
+
+#output_dir=hdfs://master:9000/user/htrc/pd-solr-json-files
+solr_url="http://10.11.0.53:8983/solr/htrc-pd-ef/update"
+
+master_opt="--master spark://10.10.0.52:7077"
+
+. scripts/_RUN.sh
+
Index: other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/scripts/_RUN.sh
===================================================================
--- other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/scripts/_RUN.sh	(revision 31042)
+++ other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/scripts/_RUN.sh	(revision 31042)
@@ -0,0 +1,100 @@
+#!/bin/bash
+
+# To work, the follow bash variables need to have been set:
+#
+#  json_filelist input_dir output_dir
+#
+# Typically done through running a wrapper script, such as:
+#
+#  RUN-PD-CLUSTER.bash
+
+if [ "x$json_filelist" = "x" ] ; then
+    echo "_RUN.bash: Failed to set 'json_filelist'" 1>&2
+    exit
+fi
+
+if [ "x$input_dir" = "x" ] ; then
+    echo "_RUN.bash: Failed to set 'input_dir'" 1>&2
+    exit
+fi
+
+#if [ "x$output_dir" = "x" ] ; then
+#    echo "_RUN.bash: Failed to set 'output_dir'" 1>&2
+#    exit
+#fi
+
+run_jps=0
+run_jps_daemons=""
+run_jps_daemons_suffix="daemon"
+using_hdfs=0
+
+if [ "x${input_dir##hdfs://*}" = "x" ] || [ "x${output_dir##hdfs://*}" = "x" ] ; then
+    # Evidence of running command over HDFS
+    run_jps=1
+    run_jps_daemons="Spark"
+    using_hdfs=1
+fi
+
+if [ "x${master_opt##--master spark://*}" = "x" ] ; then
+    # Evidence of running command submitted to Spark cluster
+    run_jps=1
+    if [ "x$run_jps_daemons" != "x" ] ; then
+        run_jps_daemons="$run_jps_daemons and Hadoop"
+	run_jps_daemons_suffix="daemons"
+    else
+        run_jps_daemons="Hadoop"
+    fi
+fi
+
+if [ "$run_jps" = "1" ] ; then
+  echo
+  echo "****"
+  echo "* Checking for $run_jps_daemons $run_jps_daemons_suffix, by running 'jps':"
+  echo "****"
+  jps | egrep -v " Jps$" |  sed 's/^/* /g'
+  echo "****"
+  echo "* Done"
+  echo "****"
+  echo
+
+  sleep 1
+fi
+
+if [ "$using_hdfs" = "1" ] ; then
+  hadoop fs -test -d "$output_dir"
+
+  if [ $? != 0 ] ; then
+      echo "Creating directory:"
+      echo "  $output_dir"
+  fi
+fi
+    
+self_contained_jar=target/htrc-ef-ingest-0.9-jar-with-dependencies.jar
+cmd="spark-submit --class org.hathitrust.extractedfeatures.ProcessForSolrIngest $master_opt $self_contained_jar"
+
+if [ "x$solr_url" != "x" ] ; then
+    cmd="$cmd --solr-url $solr_url"
+fi
+
+if [ "x$output_dir" != "x" ] ; then
+    cmd="$cmd --output-dir $output_dir"
+fi
+
+
+cmd="$cmd --properties ef-solr.properties $input_dir $json_filelist $*"
+
+echo "****"
+echo "* Lauching:"
+echo "*   $cmd"
+echo "****"
+
+if [ "$run_jps" = "1" ] ; then
+  echo "* Monitor progress on Spark cluster through:"
+  echo "*   http://10.10.0.52:8080/"
+  echo "****"
+fi
+echo
+sleep 2
+
+$cmd
+